- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Friends

# MirrorConfiguration Struct Reference

Search for all occurrences

## Detailed Description

The structure contains information about mirroring of the operation.

Definition at line 94 of file brush.h.

`#include <brush.h>`

List of all members.

## Public Member Functions
| MirrorConfiguration (void)
| Constructor.
| MirrorConfiguration (const MirrorConfiguration &v)
enum MirrorMode | MirrorMode (void) const
| Returns if the mirror is on an axis or tangent.
void | SetMirrorMode (enum MirrorMode mode)
| Sets the mirroring planes.
const Store< mudbox::Vector > & | MirrorPlaneNormals (void) const
| Returns the mirror plane normals.
const Store< mudbox::Vector > & | MirrorPlanePositions (void) const
| Returns the mirror plane positions.
bool | IsMirrorLocal (void) const
| Returns if the mirroring is local.
int | MirrorPlanes (void) const
| Returns the number of mirroring planes.
Matrix | TransformationMatrix (const SurfacePoint *pSourceLocation, bool bNormalizeLocalFrame=false) const
| Returns a matrix which transforms positions w.r.t the current mirror mode.
Vector | Transform (const Vector &cSource, float fW, const SurfacePoint *pSourceLocation) const
| Transforms a vector using the current mirror parameters in object space.
bool | operator== (const MirrorConfiguration &) const throw ()
bool | operator!= (const MirrorConfiguration &v) const throw ()
virtual void | Serialize (Stream &s)
| Serializes the configuration to the given stream.
## Friends
class | BrushOperation

## Constructor & Destructor Documentation

MirrorConfiguration | ( | void |  | ) |

Constructor.

MirrorConfiguration | ( | const MirrorConfiguration & | v | ) |

## Member Function Documentation

enum MirrorMode MirrorMode | ( | void |  | ) | const

Search for all occurrences

Returns if the mirror is on an axis or tangent.

void SetMirrorMode | ( | enum MirrorMode | mode | ) |

Search for all occurrences

Sets the mirroring planes.

const Store<mudbox::Vector>& MirrorPlaneNormals | ( | void |  | ) | const `[inline]`

Search for all occurrences

Returns the mirror plane normals.

Definition at line 104 of file brush.h.

    { return m_aMirrorPlaneNormals; };

const Store<mudbox::Vector>& MirrorPlanePositions | ( | void |  | ) | const `[inline]`

Search for all occurrences

Returns the mirror plane positions.

Definition at line 106 of file brush.h.

    { return m_aMirrorPlanePositions; };

bool IsMirrorLocal | ( | void |  | ) | const `[inline]`

Search for all occurrences

Returns if the mirroring is local.

Definition at line 108 of file brush.h.

    { return m_bMirrorLocal; };

int MirrorPlanes | ( | void |  | ) | const `[inline]`

Search for all occurrences

Returns the number of mirroring planes.

Definition at line 110 of file brush.h.

    { return m_iMirrorPlanes; };

Matrix TransformationMatrix | ( | const SurfacePoint * | pSourceLocation,
|  | bool | bNormalizeLocalFrame = `false`
| ) |  | const

Search for all occurrences

Returns a matrix which transforms positions w.r.t the current mirror mode.

Movement along two sides are scaled by the unnormalized local frames for tangent mirror mode if bNormalizeLocalFrame is false. The effect is as if the mirrored point is moving in object space.

Parameters:

  [in] | pSourceLocation | Location of a point on the surface which should be used as a reference. This point is usually
  | bNormalizeLocalFrame | close to the point which should be transformed. This parameter can be NULL, but in some cases (like for tangent space mirroring) the result will only be correct if this parameter is specified. [in] Controls if the local frames used for the tangent mirror mode is normalized

Vector Transform | ( | const Vector & | cSource,
|  | float | fW,
|  | const SurfacePoint * | pSourceLocation
| ) |  | const

Search for all occurrences

Transforms a vector using the current mirror parameters in object space.

For tangent mirror mode, the result will be scaled by the unnormalized local frame on the mirror side.

Parameters:

  [in] | cSource | Vector in object space which should be transformed
  [in] | fW | Fourth dimension of the vector. This is usually 0 when tranforming directions (to skip translations), and 1 otherwise
  [in] | pSourceLocation | Location of a point on the surface which should be used as a reference. This point is usually close to the point which should be transformed. This parameter can be NULL, but in some cases (like for tangent space mirroring) the result will only be correct if this parameter is specified.

bool operator== | ( | const MirrorConfiguration & |  | ) | const throw () `[inline]`

Definition at line 130 of file brush.h.

    { return false; };

bool operator!= | ( | const MirrorConfiguration & | v | ) | const throw () `[inline]`

Definition at line 131 of file brush.h.

    { return !operator ==( v ); };

virtual void Serialize | ( | Stream & | s | ) | `[virtual]`

Search for all occurrences

Serializes the configuration to the given stream.

## Friends And Related Function Documentation

friend class BrushOperation `[friend]`

Search for all occurrences

Definition at line 158 of file brush.h.

The documentation for this struct was generated from the following file:

- Mudbox/brush.h